



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQLite3源程序分析之查询处理及优化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQLite3源程序分析之查询处理及优化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 22:25:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>前言</h1>
<p>　　查询处理及优化是关系数据库得以流行的根本原因，也是关系数据库系统最核心的技术之一。SQLite的查询处理模块很精致，而且很容易移植到不支持SQL的存储引擎(Berkeley DB最新的版本已经将其完整的移植过来)。<br />　　查询处理一般来说，包括词法分析、语法分析、语义分析、生成执行计划以及执行计划几个部分。SQLite的词法分析器是手工写的(比较简单)，语法分析器由Lemon生成，语义分析主要是进行语义方面的一些检查，比如table是否存在等。而执行计划的生成及执行是最核心的两部分，也是相对比较复杂、有点技术含量的部分。SQLite的执行计划采用了虚拟机的思想，实际上，这种基于虚拟机的思想并非SQLite所独有，但是，SQLite将其发挥到了极致，它生成的执行计划非常详细，而且易读(不得不佩服D. Richard Hipp在编译理论方面的功底)。</p>
<h1>1、语法分析&mdash;&mdash;语法树</h1>
<p>　　语法分析的主要任务是对用户输入的SQL语句进行语法检查，然后生成一个包含所有信息的语法树。对于SELECT语句，这个语法树最终由结构体Select表示：</p>
<div>
<pre class="prettyprint linenums">struct Select {
  ExprList *pEList;      /* The fields of the result 结果的字段 */
  u8 op;                 /* One of: TK_UNION TK_ALL TK_INTERSECT TK_EXCEPT */
  char affinity;         /* MakeRecord with this affinity for SRT_Set */
  u16 selFlags;          /* Various SF_* values */
  SrcList *pSrc;         /* The FROM clause */
  Expr *pWhere;          /* The WHERE clause */
  ExprList *pGroupBy;    /* The GROUP BY clause */
  Expr *pHaving;         /* The HAVING clause */
  ExprList *pOrderBy;    /* The ORDER BY clause */
  Select *pPrior;        /* Prior select in a compound select statement 在一个复合选择语句中的优先选择 */
  Select *pNext;         /* Next select to the left in a compound */
  Select *pRightmost;    /* Right-most select in a compound select statement 在一个复合选择语句中的最右边的选择*/
  Expr *pLimit;          /* LIMIT expression. NULL means not used. */
  Expr *pOffset;         /* OFFSET expression. NULL means not used. */
  int iLimit, iOffset;   /* Memory registers holding LIMIT &amp; OFFSET counters */
  ];   /* OP_OpenEphem opcodes related to this select */
};</pre>
</div>
<p>　　该结构体中，pEList是结果列的语法树；pSrc为FROM子句的语法树；pWhere为WHERE部分的语法树。</p>
<p>　　select语法分析最终在sqlite3SelectNew中完成：</p>
<div>
<pre class="prettyprint linenums">Select *sqlite3SelectNew(
  Parse *pParse,        /* Parsing context 解析上下文 */
  ExprList *pEList,     /* which columns to include in the result 在结果中包含哪些列 */
  SrcList *pSrc,        /* the FROM clause -- which tables to scan */
  Expr *pWhere,         /* the WHERE clause */
  ExprList *pGroupBy,   /* the GROUP BY clause */
  Expr *pHaving,        /* the HAVING clause */
  ExprList *pOrderBy,   /* the ORDER BY clause */
  int isDistinct,       /* true if the DISTINCT keyword is present */
  Expr *pLimit,         /* LIMIT value.  NULL means not used */
  Expr *pOffset         /* OFFSET value.  NULL means no offset */
){
  Select *pNew;
  Select standin;
  sqlite3 *db = pParse-&gt;db;
  pNew = sqlite3DbMallocZero(db, sizeof(*pNew) );
  assert( db-&gt;mallocFailed || !pOffset || pLimit ); /* OFFSET implies LIMIT */
   ){
    pNew = &amp;standin;
    memset(pNew, , sizeof(*pNew));
  }
   ){
    pEList = sqlite3ExprListAppend(pParse, , sqlite3Expr(db,TK_ALL,));
  }
  pNew-&gt;pEList = pEList;
  pNew-&gt;pSrc = pSrc;
  pNew-&gt;pWhere = pWhere;
  pNew-&gt;pGroupBy = pGroupBy;
  pNew-&gt;pHaving = pHaving;
  pNew-&gt;pOrderBy = pOrderBy;
  pNew-&gt;selFlags = isDistinct ? SF_Distinct : ;
  pNew-&gt;op = TK_SELECT;
  pNew-&gt;pLimit = pLimit;
  pNew-&gt;pOffset = pOffset;
  assert( pOffset== || pLimit!= );
  pNew-&gt;addrOpenEphm[] = -;
  pNew-&gt;addrOpenEphm[] = -;
  pNew-&gt;addrOpenEphm[] = -;
  if( db-&gt;mallocFailed ) {
    clearSelect(db, pNew);
    if( pNew!=&amp;standin ) sqlite3DbFree(db, pNew);
    pNew = ;
  }
  return pNew;
}</pre>
</div>
<p>　　以上函数主要是将之前得到的各个子语法树汇总到Select结构体，并根据该结构，进行语义分析及执行计划的生成等工作。</p>
<p>　　<strong>示例</strong>(贯穿全文)<strong>：</strong></p>
<div>
<pre class="prettyprint linenums">explain select s.sname,c.cname,sc.grade from students s join sc join course c on s.sid=sc.sid and sc.cid = c.cid;
|Trace||||||
|Goto||||||
//////////////////////////(1)////////////////////////////
|OpenRead||||||students　　#打开students表
|OpenRead||||||sc　　　　　 #打开sc表
|OpenRead||||keyinfo(,BINARY,BINARY)||sqlite_autoindex_sc_1 #sc的索引
|OpenRead||||||course 　　 #打开course表
|OpenRead||||keyinfo(,BINARY)||sqlite_autoindex_course_1    #course的索引
//////////////////////////(2)//////////////////////////////
|Rewind||||||　　　　　　　　 #将游标p0定位到students表的第一条记录
|Column||||||students.sid　　#取出第0列,写到r1
|IsNull||||||
|Affinity||||d||
|SeekGe|||||| 　　　　　　 #将游标p3定位到sc索引&gt;=r1的记录处
|IdxGE||||||
|IdxRowid||||||
|Seek||||||
|Column||||||sc.cid 　　　　 #读取sc.cid到r3
|IsNull||||||
|Affinity||||d||
|SeekGe|||||| 　　　　　　 #将游标p4定位到course索引&gt;=r3的记录处
|IdxGE||||||
|IdxRowid||||||
|Seek||||||
///////////////////////////(3)//////////////////////////////
|Column||||||students.sname #从游标p0取出第1列 (sname)
|Column||||||course.cname 　#从游标p2取出第1列 (cname)
|Column||||||sc.grade 　　　 #从游标p1取出第2列 (grade)
|ResultRow||||||
///////////////////////////(4)///////////////////////////////
|Next||||||
|Next||||||
|Next||||||
|Close||||||
|Close||||||
|Close||||||
|Close||||||
|Close||||||
//////////////////////////(5)//////////////////////////////////
|Halt||||||
|Transaction||||||
|VerifyCookie||||||
|TableLock||||students||
|TableLock||||sc||
|TableLock||||course||
|Goto||||||</pre>
</div>
<p>　　<strong>该SQL语句生成的语法树如下：</strong></p>
<p><strong>FROM部分：</strong></p>
<p>第一个表项：<br /><img referrerpolicy="no-referrer"src="http://images.cnblogs.com/cnblogs_com/hustcat/2010/sqlite10-1.JPG" /></p>
<p>表名zName =&rdquo;stduents&rdquo;，zAlias=&rdquo;s&rdquo;，jointype = 0</p>
<p>第二个表项：<br /><img referrerpolicy="no-referrer"src="http://images.cnblogs.com/cnblogs_com/hustcat/2010/sqlite10-2.JPG" /></p>
<p>jointype = 1(JT_INNER)</p>
<p>第三个表项：<br /><img referrerpolicy="no-referrer"src="http://images.cnblogs.com/cnblogs_com/hustcat/2010/sqlite10-3.JPG" /></p>
<p>jointype = 1(JT_INNER)</p>
<p><strong>WHERE部分</strong>(结点类型为Expr的一棵二叉树)<strong>：</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images.cnblogs.com/cnblogs_com/hustcat/sqlite10-4.JPG" /></p>
<h1>2、生成执行计划(语法树到OPCODE)</h1>
<p>　　Select的执行计划在sqlite3Select中完成：</p>
<div>
<pre class="prettyprint linenums">int sqlite3Select(
  Parse *pParse,         /* The parser context */
  Select *p,             /* SELECT语法树 */
  SelectDest *pDest      /* 如何处理结果集 */
)</pre>
</div>
<p>　　该函数先对SQL语句进行语义分析，再进行优化，最后生成执行计划。</p>
<p>　　对于上面的SQL语句，生成的执行计划(虚拟机opcode)大致分成5部分，前4部分都在sqlite3Select()中生成，它主要调用了以下几个函数：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnblogs.com/cnblogs_com/hustcat/2010/sqlite10-5.JPG" /></p>
<p>　　其中(1)、(2)在sqlite3WhereBegin()中生成，(2)即所谓的查询优化处理；(3)在 selectInnerLoop中生成；(4)在sqlite3WhereEnd中生成；(5)在sqlite3FinishCoding中完成。　</p>
<h2><strong>　<em>1）sqlite3WhereBegin</em></strong></h2>
<p>　　该函数是查询处理最为核心的函数，它主要完成where部分的优化及相关opcode的生成。</p>
<div>
<pre class="prettyprint linenums">WhereInfo *sqlite3WhereBegin(
  Parse *pParse,        /* The parser context */
  SrcList *pTabList,    /* A list of all tables to be scanned 要扫描的所有表的列表*/
  Expr *pWhere,         /* The WHERE clause */
  ExprList **ppOrderBy, /* An ORDER BY clause, or NULL */
  u16 wctrlFlags        /* One of the WHERE_* flags defined in sqliteInt.h */
)</pre>
</div>
<p>　　pTabList是由分析器对FROM部分生成的语法树，它包含FROM语句中的表的信息；pWhere是WHERE部分的语法树，它包含WHERE中所有表达式的信息；ppOrderBy对应ORDER BY子句。</p>
<p>　　SQLite的查询优化简单而精致，在sqlite3WhereBegin函数中，即可完成所有的优化处理。查询优化的基本理念就是<strong>嵌套循环</strong>(nested loop)，SELECT语句的FROM子句的每个表对应一层循环(INSERT和UPDATE语句对应只有一个表)。例如：</p>
<div>
<pre class="prettyprint linenums">SELECT * FROM t1, t2, t3 WHERE ...;</pre>
</div>
<p>　　进行如下操作：</p>
<div>
<pre class="prettyprint linenums">foreach row1 in t1 do       \    Code generated
  foreach row2 in t2 do      |-- by sqlite3WhereBegin()
    foreach row3 in t3 do   /
      ...
    end                     \    Code generated
  end                        |-- by sqlite3WhereEnd()
end                         /</pre>
</div>
<p>　　而对于每一层的优化，基本的理念就是分析WHERE子句中是否有表达式能够使用该层循环的表的索引。</p>
<p>　　<strong>SQLite有三种基本的扫描策略：</strong></p>
<p>　　&nbsp;①&nbsp;全表扫描，这种情况通常出现在没有WHERE子句时；</p>
<p>　　&nbsp;②&nbsp;基于索引扫描，这种情况通常出现在表有索引，而且WHERE中的表达式又能够使用该索引的情况；</p>
<p>　　&nbsp;③&nbsp;基本rowid的扫描，这种情况通常出现在WHERE表达式中含有rowid的条件。(该情况实际上也是对表进行扫描，SQLite以rowid为聚簇索引)</p>
<p>　　第一种情况比较简单，第三种情况与第二种情况没有本质的差别。下面就第二种情况进行详细讨论。</p>
<p>　　以下为<strong>sqlite3WhereBegin</strong>的关键<strong>代码：</strong></p>
<div>
<pre class="prettyprint linenums">/*分析where子句的所有表达式**如果表达式的形式为X &lt;op&gt; Y,则增加一个Y &lt;op&gt; X形式的虚Term,并在后面进行单独分析*/
exprAnalyzeAll(pTabList, pWC);
WHERETRACE(("*** Optimizer Start ***\n"));
//优化开始
, pLevel=pWInfo-&gt;a; i&lt;nTabList; i++, pLevel++){
    WhereCost bestPlan;         /* Most efficient plan seen so far 迄今为止最有效的计划 */
    Index *pIdx;                /* Index for FROM table at pTabItem */
    int j;                      /* For looping over FROM tables 从表循环*/
    ;             /* The value of j */
    Bitmask m;                  /* Bitmask value for j or bestJ */
    int isOptimal;              /* Iterator for optimal/non-optimal search 优化/非优化搜索的迭代器 */

    memset(&amp;bestPlan, , sizeof(bestPlan));
    bestPlan.rCost = SQLITE_BIG_DBL;

    /*进行两次扫描:*/
　　//如果第一次扫描没有找到优化的扫描策略,此时,isOptimal==0,bestJ==-1,则进行第二次扫描
    ; isOptimal&gt;= &amp;&amp; bestJ&lt;; isOptimal--){
　　　 //第一次扫描的mask==0,表示所有表都已经准备好
      Bitmask mask = (isOptimal ?  : notReady);
      assert( (nTabList-iFrom)&gt; || isOptimal );

      for(j=iFrom, pTabItem=&amp;pTabList-&gt;a[j]; j&lt;nTabList; j++, pTabItem++){
        int doNotReorder;    /* True if this table should not be reordered 如果该表不应该被重新排序为True */
        WhereCost sCost;     /* Cost information from best[Virtual]Index() */
        ExprList *pOrderBy;  /* ORDER BY clause for index to optimize */

　　　　 //对于左连接和交叉连接,不能改变嵌套的顺序
        doNotReorder =  (pTabItem-&gt;jointype &amp; (JT_LEFT|JT_CROSS))!=;

        if( j!=iFrom &amp;&amp; doNotReorder ) //如果j==iFrom,仍要进行优化处理(此时,是第一次处理iFrom项)
            break;
        m = getMask(pMaskSet, pTabItem-&gt;iCursor);
         ){//如果该pTabItem已经进行处理,则不需要再处理
          if( j==iFrom )
              iFrom++;
          continue;
        }
        pOrderBy = ((i== &amp;&amp; ppOrderBy )?*ppOrderBy:);

        {
          //对一个表(pTabItem),找到它的可用于本次查询的最好的索引,sCost返回对应的代价
          <strong>bestBtreeIndex</strong>(pParse, pWC, pTabItem, mask, pOrderBy, &amp;sCost);
        }

         &amp;&amp; (j==iFrom || sCost.rCost&lt;bestPlan.rCost)
        ){
          bestPlan = sCost;
          bestJ = j; //如果bestJ&gt;=0,表示找到了优化的扫描策略
        }
        if( doNotReorder ) break;
      }//end for
    }//end for
    WHERETRACE(("*** Optimizer selects table %d for loop %d\n", bestJ,
           pLevel-pWInfo-&gt;a));

     ){//不需要进行排序操作
      *ppOrderBy = ;
    }
　　//设置该层选用的查询策略
　　andFlags &amp;= bestPlan.plan.wsFlags;
　　pLevel-&gt;plan = bestPlan.plan;

　　//如果可以使用索引,则设置索引对应的游标的下标
　　if( bestPlan.plan.wsFlags &amp; WHERE_INDEXED ){
      pLevel-&gt;iIdxCur = pParse-&gt;nTab++;
　　}else{
      pLevel-&gt;iIdxCur = -;
　　}
　　notReady &amp;= ~getMask(pMaskSet, pTabList-&gt;a[bestJ].iCursor);
　　//该层对应的FROM的表项,即该层循环是对哪个表进行的操作
　　pLevel-&gt;iFrom = (u8)bestJ;

}
//优化结束
WHERETRACE(("*** Optimizer Finished ***\n"));</pre>
</div>
<p>　　优化部分的代码的基本算法如下：</p>
<div>
<pre class="prettyprint linenums">foreach  level  in all_levels
bestPlan.rCost = SQLITE_BIG_DBL
foreach table in tables that not handled
{
    //计算where中表达式能使用其索引的策略及代价rCost
    If(sCost.rCost &lt; bestPlan.rCost)
      bestPlan = sCost
}
level.plan = bestPlan</pre>
</div>
<p>　　该算法本质上是一个贪婪算法(greedy algorithm)。其中，bestBtreeIndex(pParse, pWC, pTabItem, mask, pOrderBy, &amp;sCost)是pParse对应的表针对where子句的表达式分析查询策略的核心函数。</p>
<p>　　对于之前的示例，经过以上优化处理后，得到的查询策略分3层循环，最外层是students表，全表扫描；中间层是sc表，利用索引sqlite_autoindex_sc_1，即sc的key对应的索引；内层是course表，利用索引sqlite_autoindex_course_1。</p>
<p>　　之后，开始生成(1)、(2)两部分opcode。</p>
<p>　　其中<strong>(1)的opcode由以下代码生成：</strong></p>
<div>
<pre class="prettyprint linenums">//生成打开表的指令

　　&amp;&amp; (wctrlFlags &amp; WHERE_OMIT_OPEN)== ){
　　//pTabItem-&gt;iCursor为表对应的游标下标
　　int op = pWInfo-&gt;okOnePass ? OP_OpenWrite : OP_OpenRead;
　　sqlite3OpenTable(pParse, pTabItem-&gt;iCursor, iDb, pTab, op);
}

//生成打开索引的指令
 ){
　　Index *pIx = pLevel-&gt;plan.u.pIdx;
　　KeyInfo *pKey = sqlite3IndexKeyinfo(pParse, pIx);
　　int iIdxCur = pLevel-&gt;iIdxCur; //索引对应的游标下标
　　sqlite3VdbeAddOp4(v, OP_OpenRead, iIdxCur, pIx-&gt;tnum, iDb,(char*)pKey, P4_KEYINFO_HANDOFF);　　VdbeComment((v, "%s", pIx-&gt;zName)); }</pre>
</div>
<p>　　而<strong>(2)的opcode由以下代码生成：</strong></p>
<div>
<pre class="prettyprint linenums">　notReady = ~(Bitmask);
  ; i&lt;nTabList; i++){
    //核心代码,从最外层向最内层,为每一层循环生成opcode
    notReady =<strong> codeOneLoopStart</strong>(pWInfo, i, wctrlFlags, notReady);
    pWInfo-&gt;iContinue = pWInfo-&gt;a[i].addrCont;
  }</pre>
</div>
<p>　　其中codeOneLoopStart(pWInfo, i, wctrlFlags, notReady)函数，根据优化分析得到的结果生成每层循环的opcode：</p>
<div>
<pre class="prettyprint linenums">static Bitmask codeOneLoopStart(
  WhereInfo *pWInfo,   /* Complete information about the WHERE clause */
  int iLevel,          /* Which level of pWInfo-&gt;a[] should be coded */
  u16 wctrlFlags,      /* One of the WHERE_* flags defined in sqliteInt.h */
  Bitmask notReady     /* Which tables are currently available */
)</pre>
</div>
<p>　　<strong>codeOneLoopStart</strong>针对5种不同的查询策略，<strong>生成</strong>各自不同的<strong>opcode:</strong></p>
<div>
<pre class="prettyprint linenums">if( pLevel-&gt;plan.wsFlags &amp; WHERE_ROWID_EQ ){　　//rowid的等值查询
...
}else if( pLevel-&gt;plan.wsFlags &amp; WHERE_ROWID_RANGE ){　　//rowid的范围查询
...
}else if( pLevel-&gt;plan.wsFlags &amp; (WHERE_COLUMN_RANGE|WHERE_COLUMN_EQ) ){　　//使用索引的等值/范围查询
...
}if( pLevel-&gt;plan.wsFlags &amp; WHERE_MULTI_OR ){　　//or
...
}else{　　//全表扫描
...
}</pre>
</div>
<p>　　其中，<strong>全表扫描</strong>如下<strong>：</strong></p>
<div>
<pre class="prettyprint linenums">static const u8 aStep[] = { OP_Next, OP_Prev };
static const u8 aStart[] = { OP_Rewind, OP_Last };
pLevel-&gt;op = aStep[bRev];
pLevel-&gt;p1 = iCur;
pLevel-&gt;p2 =  + sqlite3VdbeAddOp2(v, aStart[bRev], iCur, addrBrk); //生成OP_Rewind/OP_Last指令
pLevel-&gt;p5 = SQLITE_STMTSTATUS_FULLSCAN_STEP;</pre>
</div>
<p>　　示例中最外层循环students是全表扫描，生成指令7。</p>
<p>　　其中，<strong>利用索引的等值/范围查询：</strong></p>
<p>　　对于示例：中间循环sc表，用到索引，指令8~14是对应的opcode。<br />　　　　　　　内层循环course表，也用到索引，指令15~21是对应的opcode。</p>
<p>　　在通用数据库中，连接操作会生成所谓的结果集(用临时表存储)。而SQLite不会生成中间结果集，例如示例中，会分别对students、sc和course表各分配一个游标，每次调用接口sqlite3_step时，游标根据where条件分别定位到各自的记录，然后取出查询输出列的数据，放到用于存放结果的寄存器中(如示例(3)中的opcode)。所以在SQLite中，必须不断调用sqlite3_step才能读取所有记录。</p>
<h2>　<em>2）selectInnerLoop</em></h2>
<p>　　该函数主要生成输出结果列的opcode，即示例(3)中的opcode。</p>
<h2>　<em>3）sqlite3WhereEnd</em></h2>
<p>　　该函数主要完成嵌套循环的收尾工作的opcode的生成，为每层循环生成OP_Next/OP_Prev，以及关闭表和索引游标的OP_Close。</p>
<h1>3、SQLite的代价模型</h1>
<p>　　再看bestBtreeIndex函数，其完成查询代价的计算以及查询策略的确定。</p>
<p>　　SQLite采用基于代价的优化。根据处理查询时CPU和磁盘I/O的代价，主要考虑以下一些因素：<br />　　 A、查询读取的记录数；<br />　　 B、结果是否排序(这可能会导致使用临时表)；<br />　　 C、是否需要访问索引和原表。</p>
<div>
<pre class="prettyprint linenums">static void bestBtreeIndex(
  Parse *pParse,              /* The parsing context */
  WhereClause *pWC,           /* The WHERE clause */
  struct SrcList_item *pSrc,  /* The FROM clause term to search */
  Bitmask notReady,           /* Mask of cursors that are not available */
  ExprList *pOrderBy,         /* The ORDER BY clause */
  WhereCost *pCost            /* Lowest cost query plan */
)</pre>
</div>
<p>　　该函数的主要工作就是输出pCost，它包含查询策略信息及相应的代价。</p>
<p>　　其<strong>核心算法</strong>如下<strong>：</strong></p>
<div>
<pre class="prettyprint linenums">//遍历其所有索引,找到一个代价最小的索引
for(; pProbe; pIdx=pProbe=pProbe-&gt;pNext){
    const unsigned int * const aiRowEst = pProbe-&gt;aiRowEst;
    double cost;                /* Cost of using pProbe */
    double nRow;                /* Estimated number of rows in result set */
    int rev;                    /* True to scan in reverse order */
    ;
    Bitmask used = ; 　 //该表达式使用的表的位码

    int nEq;        　　 //可以使用索引的等值表达式的个数
    ;     //如果存在 x IN (SELECT...),则设为true
    ;     //处理IN子句
    ;   //估计需要扫描的表中的元素,100表示需要扫描整个表,范围条件意味着只需要扫描表的某一部分
    ;      //是否需要排序
    ;    //如果对索引中的每个列,需要对应的表进行查询,则为true

    /* Determine the values of nEq and nInMul */
    //计算nEq和nInMul值
    ; nEq&lt;pProbe-&gt;nColumn; nEq++){
      WhereTerm *pTerm; /* A single term of the WHERE clause */
      int j = pProbe-&gt;aiColumn[nEq];
      pTerm = findTerm(pWC, iCur, j, notReady, eqTermMask, pIdx);
       ) //如果该条件在索引中找不到,则break
          break;
      wsFlags |= (WHERE_COLUMN_EQ|WHERE_ROWID_EQ);
      if( pTerm-&gt;eOperator &amp; WO_IN ){
        Expr *pExpr = pTerm-&gt;pExpr;
        wsFlags |= WHERE_COLUMN_IN;
        if( ExprHasProperty(pExpr, EP_xIsSelect) ){ //IN (SELECT...)
          nInMul *= ;
          bInEst = ;
        }else if( pExpr-&gt;x.pList ){
          nInMul *= pExpr-&gt;x.pList-&gt;nExpr + ;
        }
      }else if( pTerm-&gt;eOperator &amp; WO_ISNULL ){
        wsFlags |= WHERE_COLUMN_NULL;
      }
      used |= pTerm-&gt;prereqRight; //设置该表达式使用的表的位码
    }

    //计算nBound值
    if( nEq&lt;pProbe-&gt;nColumn ){//考虑不能使用索引的列
      int j = pProbe-&gt;aiColumn[nEq];
      if( findTerm(pWC, iCur, j, notReady, WO_LT|WO_LE|WO_GT|WO_GE, pIdx) ){
        WhereTerm *pTop = findTerm(pWC, iCur, j, notReady, WO_LT|WO_LE, pIdx);
        WhereTerm *pBtm = findTerm(pWC, iCur, j, notReady, WO_GT|WO_GE, pIdx);//&gt;=

        //估计范围条件的代价
        whereRangeScanEst(pParse, pProbe, nEq, pBtm, pTop, &amp;nBound);
        if( pTop ){
          wsFlags |= WHERE_TOP_LIMIT;
          used |= pTop-&gt;prereqRight;
        }
        if( pBtm ){
          wsFlags |= WHERE_BTM_LIMIT;
          used |= pBtm-&gt;prereqRight;
        }
        wsFlags |= (WHERE_COLUMN_RANGE|WHERE_ROWID_RANGE);
      }
    }else if( pProbe-&gt;onError!=OE_None ){//所有列都能使用索引
       ){
        wsFlags |= WHERE_UNIQUE;
      }
    }

    if( pOrderBy ){//处理order by

        &amp;&amp; isSortingIndex(pParse,pWC-&gt;pMaskSet,pProbe,iCur,pOrderBy,nEq,&amp;rev)
      ){
        wsFlags |= WHERE_ROWID_RANGE|WHERE_COLUMN_RANGE|WHERE_ORDERBY;
        wsFlags |= (rev ? WHERE_REVERSE : );
      }else{
        bSort = ;
      }
    }

    if( pIdx &amp;&amp; wsFlags ){
      Bitmask m = pSrc-&gt;colUsed; //m为src使用的列的位图
      int j;
      ; j&lt;pIdx-&gt;nColumn; j++){
        int x = pIdx-&gt;aiColumn[j];
         ){
          m &amp;= ~(((Bitmask))&lt;&lt;x); //将索引中列对应的位清0
        }
      }
       ){//如果索引包含src中的所有列,则只需要查询索引即可
        wsFlags |= WHERE_IDX_ONLY;
      }else{
        bLookup = ;//需要查询原表
      }
    }

    //估计输出行数,同时考虑IN运算
    nRow = (double)(aiRowEst[nEq] * nInMul);
    &gt;aiRowEst[] ){
      nRow = aiRowEst[]/;
      nInMul = (int)(nRow / aiRowEst[nEq]);
    }

    //代价为输出的行数+二分查找的代价
    cost = nRow + nInMul*estLog(aiRowEst[]);

    //考虑范围条件影响
    nRow = (nRow * (;
    cost = (cost * (;

    //加上排序的代价:cost *log (cost)
    if( bSort ){
      cost += cost*estLog(cost);
    }

    //如果只查询索引,则代价减半
     ){
      cost /= (;
    }

    //如果当前的代价更小
    if( (!pIdx || wsFlags) &amp;&amp; cost&lt;pCost-&gt;rCost ){
      pCost-&gt;rCost = cost; //代价
      pCost-&gt;nRow = nRow;  //估计扫描的元组数
      pCost-&gt;used = used; //表达式使用的表的位图
      pCost-&gt;plan.wsFlags = (wsFlags&amp;wsFlagMask); //查询策略标志(全表扫描,使用索引进行扫描)
      pCost-&gt;plan.nEq = nEq; //查询策略使用等值表达式个数
      pCost-&gt;plan.u.pIdx = pIdx; //查询策略使用的索引(全表扫描则为NULL)
    }

    //如果SQL语句存在INDEXED BY,则只考虑该索引
    if( pSrc-&gt;pIndex ) break;

    /* Reset masks for the next index in the loop */
    wsFlagMask = ~(WHERE_ROWID_EQ|WHERE_ROWID_RANGE);
    eqTermMask = idxEqTermMask;
  }</pre>
</div>
<p>　　SQLite的代价模型比较简单，而通用数据库一般是将基于规则的优化和基于代价的优化结合起来，更为复杂。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390r0o39.html">Spark入门实战系列--10&period;分布式内存文件系统Tachyon介绍及安装部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q254kvq.html">mysql null值处理详细说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdz6o8.html">LeetCode之171&period; Excel Sheet Column Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prl1yq.html">爆料喽！！！开源日志库Logger的使用秘籍</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2jg48.html">关闭log4j 输出  DEBUG org&period;apache&period;commons&period;beanutils&period;&ast;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oz31x9.html">5&period;HBase In Action 第一章-HBase简介（1&period;1&period;3 HBase的兴起）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1j3x39.html">全局变量&amp;amp&semi;局部变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m27pgq.html">CSS&mdash;换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdzkel8.html">OpenResty</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmdnmk9.html">&lbrack;Redux&rsqb; Using mapDispatchToProps&lpar;&rpar; Shorthand Notation</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjgn528.html">if 分支语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdv0w8.html">Best MVC Practices&lpar;最优的MVC布局&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1or3oq.html">JVM笔记2-Java虚拟机内存管理简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6pdpq.html">AI应用开发实战 - 从零开始搭建macOS开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5yeg9.html">hibernate出现QueryException&colon; could not resolve property   查询异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7mxg8.html">Python-待</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2003j9.html">用VS制作的windows服务安装包 安装完后如何让服务自动启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv232mx9.html">Java Bug --  java&period;util&period;ConcurrentModificationException</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkj0rd8.html">opencv中的缩放函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn4pm2q.html">读《构建之法》一、二、十六章随笔a</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8k7059j.html">从express源码中探析其路由机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kwp58j.html">前端渲染利器&mdash;&mdash;JsRender入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxnwnj8.html">关于XHR对象中status范围的记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wdyvq.html">做linux运维工程师，必须要掌握以下几个工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwddkl8.html">AEAI ESB培训大纲</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rdg7e8.html">移动信息化不能延续PC时代的痛</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn1jg28.html">如何禁止内部viewPager滑动</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93xw409.html">RSS阅读器</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ok1x59.html">js动态获取子复选项并设计全选及提交</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qydvddq.html">SSIS 实例&mdash;&mdash;将SQL获取的信息传递到Email中</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
